--- old/usr/src/cmd/nsadmin/Makefile	2013-11-28 11:13:28.721253324 +0400
+++ new/usr/src/cmd/nsadmin/Makefile	2013-11-28 11:13:28.732933485 +0400
@@ -30,6 +30,9 @@
 include ../Makefile.cmd
 
 ROOTROOT= $(ROOT)/root
+ROOTETCCSH= $(ROOTETC)/csh
+ROOTETCCSHLOGIND= $(ROOTETC)/csh/login.d
+ROOTETCPROFILED= $(ROOTETC)/profile.d
 ROOTETCSKEL= $(ROOTETC)/skel
 ROOTETCSKELPROG= $(PROGSKEL:%=$(ROOTETCSKEL)/%)
 ROOTROOTPROG= $(PROGROOT:%=$(ROOTROOT)/%)
@@ -62,10 +65,13 @@
 	$(INS.file)
 
 $(ROOTROOT) \
+$(ROOTETCCSH) \
+$(ROOTETCCSHLOGIND) \
+$(ROOTETCPROFILED) \
 $(ROOTETCSKEL):
 	$(INS.dir)
 
-install: all $(ROOTETCSKEL) $(ROOTETCPROG) $(ROOTETCSKELPROG) $(ROOTROOTPROG)
+install: all $(ROOTETCCSH) $(ROOTETCCSHLOGIND)  $(ROOTETCPROFILED) $(ROOTETCSKEL) $(ROOTETCPROG) $(ROOTETCSKELPROG) $(ROOTROOTPROG)
 
 clean:
 
--- old/usr/src/cmd/nsadmin/etc-profile.sh	2013-11-28 11:13:29.050187707 +0400
+++ new/usr/src/cmd/nsadmin/etc-profile.sh	2013-11-28 11:13:29.063939009 +0400
@@ -21,6 +21,8 @@
 # Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
+# Copyright 2013 Alexander Pyhalov. All rights reserved.
+#
 
 # The profile that all logins get before using their own .profile.
 
@@ -62,6 +64,17 @@
 		   	;;
 		esac
 	fi
+
+	if [ -d /etc/profile.d -a ! -f "${HOME}/.limited_profile" ] 
+	then
+		for file in /etc/profile.d/*.sh ; do
+			if [ -f "$file" -a -r "$file" ] 
+			then
+				source "$file"
+			fi
+		done
+		unset file
+	fi
 esac
 
 umask 022
--- old/usr/src/cmd/nsadmin/ksh.kshrc	2013-11-28 11:13:29.374703063 +0400
+++ new/usr/src/cmd/nsadmin/ksh.kshrc	2013-11-28 11:13:29.387109043 +0400
@@ -33,11 +33,11 @@
 # "set -o" flag)
 if [[ "$(set +o)" != ~(Er)--(gmacs|emacs|vi)( .*|) ]] ; then
 	set -o gmacs
-	# enable multiline input mode
-	set -o multiline
-	# enable globstar mode (match subdirs with **/)
-	set -o globstar
 fi
+# enable multiline input mode
+set -o multiline
+# enable globstar mode (match subdirs with **/)
+set -o globstar
 
 # Set a default prompt (<username>@<hostname>:<path><"($|#) ">) if
 # then variable does not exist in the environment.
--- old/usr/src/cmd/nsadmin/login.csh	2013-11-28 11:13:29.695050284 +0400
+++ new/usr/src/cmd/nsadmin/login.csh	2013-11-28 11:13:29.707605118 +0400
@@ -21,7 +21,8 @@
 # Copyright 1998 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
-#ident	"%Z%%M%	%I%	%E% SMI"
+# Copyright 2013 Alexander Pyhalov. All rights reserved.
+#
 
 # The initial machine wide defaults for csh.
 
@@ -54,3 +55,27 @@
 		breaksw;
 	endsw
 endif
+
+if ( -d /etc/csh/login.d && ! -f "${HOME}/.limited_profile" ) then
+	if ($?nonomatch) then 
+		set old=$nonomatch
+	else
+		unset old
+	endif
+	set nonomatch=1
+	foreach file ( /etc/csh/login.d/*.csh )
+		if ( "$file" == "/etc/csh/login.d/*.csh" ) then
+			break
+		endif
+		if ( -f "$file" && -r "$file" ) then
+			source "$file"
+		endif
+	end
+	if ($?old) then
+		set nonomatch="$old"
+		unset old
+	else 
+		unset nonomatch
+	endif
+	unset file
+endif
--- old/usr/src/pkg/manifests/SUNWcs.mf	2013-11-28 11:13:30.021705253 +0400
+++ new/usr/src/pkg/manifests/SUNWcs.mf	2013-11-28 11:13:30.034760825 +0400
@@ -39,6 +39,8 @@
 set name=variant.arch value=$(ARCH)
 dir path=dev group=sys
 dir path=etc group=sys
+dir path=etc/csh group=sys
+dir path=etc/csh/login.d group=sys
 dir path=etc/cron.d group=sys
 dir path=etc/crypto group=sys
 dir path=etc/crypto/certs group=sys
@@ -63,6 +65,7 @@
 dir path=etc/net/ticots group=sys
 dir path=etc/net/ticotsord group=sys
 dir path=etc/opt group=sys
+dir path=etc/profile.d group=sys
 dir path=etc/rc0.d group=sys
 dir path=etc/rc1.d group=sys
 dir path=etc/rc2.d group=sys
@@ -405,7 +408,7 @@
 file path=etc/nsswitch.ldap group=sys
 file path=etc/pam.conf group=sys preserve=true
 file path=etc/passwd group=sys preserve=true
-file path=etc/profile group=sys preserve=true
+file path=etc/profile group=sys preserve=renamenew
 file path=etc/project group=sys preserve=true
 file path=etc/rc2.d/README group=sys
 file path=etc/rc3.d/README group=sys
